#
# This scripts set the max and  minimum heap size.
# wsadmin.bat -user userid -password password -f fabricSetHeapsize.py servername initheap maxheap
#


###########################################################
# Prints error message on the console
###########################################################
def validationError (errorMessage) :
    print ""
    print "*********************************************"
    print "Error -"
    print errorMessage
    print "*********************************************"
    print ""
    sys.exit()


################################################################
#Variable declaration.

nodeName = ""
nodeId = ""
inputInitialHeapSize = ""
inputMaxHeapSize = ""
serverName = ""

###############################################################


if ((len(sys.argv) == 0)):
    validationError("No inputs provided. Mimimum nodename needs to be provided.")
        
    ###################################################################
    # Command line parameters passed in. Evaluate each of these paramters
    ###################################################################
else:
    nodeName = sys.argv[0]
    nodeId=AdminConfig.getid("/Node:"+nodeName+"/")
    if (nodeId==""):
        validationError("Node "+ nodeName + "doesn't exist")

    args = []
    args.append("-nodeName")
    args.append(nodeName)
    print AdminTask.isNodeZOS(args)
    if(AdminTask.isNodeZOS(args).upper() == "FALSE") :
        try :
            inputInitialHeapSize = sys.argv[1]
        except :
            inputInitialHeapSize = 256
    
        try :
            inputMaxHeapSize = sys.argv[2]
        except :
            inputMaxHeapSize = 1024
	
        if(len(serverName) < 1):
            servers = AdminConfig.list("Server", nodeId)
            serversList = servers.split(lineSeparator)
	    serverName =  AdminConfig.showAttribute(serversList[0], "name")
    
        serverId=AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")
        if (serverId==""):
            validationError("Server "+ serverName + " doesn't exist")

        s1pdefs = AdminConfig.list('ProcessDef', serverId).split("\n")

        for pd in s1pdefs:

            jvmList = AdminConfig.list('JavaVirtualMachine',pd).splitlines()

            for jvm in jvmList :
                initialHeapSize = int(AdminConfig.showAttribute(jvm, 'initialHeapSize'))
	        print "The initial heap size set on sever is " + str(initialHeapSize )
                AdminConfig.modify(jvm,[['initialHeapSize',inputInitialHeapSize]])
                print "The initial heap size is now set to " + str(inputInitialHeapSize) 
                maxHeapSize = int(AdminConfig.showAttribute(jvm, 'maximumHeapSize'))
                print "The max heap size set on server is " + str(maxHeapSize)
                AdminConfig.modify(jvm,[['maximumHeapSize',inputMaxHeapSize]])
                print "The max heap size is now set to " + str(inputMaxHeapSize) 
            break    
 
 
        #
        #   Save the Config
        #
        AdminConfig.save()

        print "fabricSetHeapsize completed."
    else :
        print "Z/OS Node detected.Heapsize not set."